-----------------
--main menu entry
-----------------
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:Track Groove",
  invoke = function() main()
  end
}
---------------------------------
--keybinding
---------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:Track Groove",
  invoke = function()main()end
}

--e.g. For changing vb.views["sample present colour 2"].color when states change
COLOR_GREY = {0x30,0x42,0x42}
COLOR_ORANGE ={0xFF,0x66,0x00}
COLOR_YELLOW = {0xE0,0xE0,0x00}
COLOR_BLUE = {0x50,0x40,0xE0}  
COLOR_RED = {0xEE,0x10,0x10}
COLOR_GREEN = {0x20,0x99,0x20}


RED_COORDINATE = 0xEE

--GUI Global
my_dialog = nil --don`t declare as local as not in main file 
vb = renoise.ViewBuilder()

--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
local function status(message)
  renoise.app():show_status("Track Groove Tool: ("..message..")")
end

-------------------------------------------
--main
-------------------------------------------
function main()

  --1 dialog at a time
  if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
    my_dialog:close()
    return
  end
  
  --reset vb otherwise old one is not released sometimes???
  vb = renoise.ViewBuilder()
  
  --song object
  local song = renoise.song()


  ------------  
  --Build GUI
  ------------
  ----------------------------------------------------------------
  ----------------------------------------------------------------
  
  local title = "Track Groove"
  local dialog_content = vb:column {
  
  --text
  vb:vertical_aligner{
   margin = 10,
   mode = "center",
   
   
  ------------------------------------------
  --text
  ------------------------------------------

    vb:text{
     text = "Beat Rows (even):",
    }, 
    
    vb:horizontal_aligner{
     vb:text{
      text = "    Velocity         Delay            Pan ",
      font = "bold",
     }, 
    },--h_aligner

   ------------------------------------------
   --rotaries, 1st row
   ------------------------------------------
   
   vb:row{ --top row of rotaries (and [X] buttons)
     margin = 10,
     style = "group",
     
     vb:vertical_aligner{ --contains velocity rotary and [X] button
      mode = "justify",
     
      vb:rotary{
       min = 1,
       max = 130,
       width = 50,
       height = 50,
       notifier = function(value)
       
                   --pattern variables
                   local song = renoise.song() 
                   local pattern = renoise.song().selected_pattern
                   local pattern_length = pattern.number_of_lines
                   local pattern_track = renoise.song().selected_pattern_track
                   
                   --if on fx track then return
                   if song.tracks[song.selected_track_index].type ~= renoise.Track.TRACK_TYPE_SEQUENCER then
                     status("Tool Only Works On Sequencer Tracks")
                     return
                   end
                   
                    --is record enabled
                   local record_val = 0    
                   if vb.views["record"].color[1] == RED_COORDINATE then
                     record_val = 1
                   end
                                      
                    --make volume column visible
                   if song.selected_track.volume_column_visible == false then
                     song.selected_track.volume_column_visible = true
                   end
                   --get number of visible columns as these will be the ones we change the values of
                   local visible_columns = song.selected_track.visible_note_columns
                      
                      
                   --default values for the range in pattern for tool to effect
                   ----------------------------------------------------------
                   local start_line = 1
                   local end_line = pattern_length

                   --if record enabled then set the values to the shorter range
                   if record_val == 1 then
                     start_line = renoise.song().selected_line_index 
                     end_line = start_line + 1
                   end
                   
                   --lua counts from 1, renoise pattern ed counts from 0, so:
                   value = value - 1
                 
                   --when volume is at max, clear the volume column as this is tracker default
                   if value == 129 then
                     value = renoise.PatternLine.EMPTY_VOLUME --(EMPTY_VOL == 255)
                   end
                                      
                   for row = start_line,end_line do --pattern_length do                     
                     if row % 2 == 0 then
                       --do nothing
                     else
                       --set the delay value
                       for col = 1,visible_columns do
                         if pattern_track:line(row):note_column(col).note_string ~= "---" then 
                           --set the column values
                           pattern_track:line(row):note_column(col).volume_value = value
                         end
                       end 
                     end
                   end
                 end
                       
                      
                      
                     
               
      },
       --Clear [X] Button    
       vb:button{
        text = "X",
        notifier = function()
        
                    local song = renoise.song()
                    local visible_columns = song.selected_track.visible_note_columns
                    
                     --loop to clear rotary related values related                    
                    for row = 1, #song.selected_pattern_track.lines do
                      if row % 2 == 0 then
                       --do nothing
                      else
                       --clear the velocity column
                        for col = 1,visible_columns do
                          song.selected_pattern_track:line(row):note_column(col).volume_value = renoise.PatternLine.EMPTY_VOLUME
                        end
                      end
                    end    
                  end--fn
       },--button 
     
      },--vert align(top ro Velocity)
      
      --spacer
      vb:text{
       text = "  ",
       
        },
        
         
     vb:vertical_aligner{ --contains velocity rotary and [X] button
      mode = "justify",
       
      --------------------------------------------------------------------------------------
      --delay row 1
      ---------------------------------------------------------------------------------------
      vb:rotary{
        min = 1,
       max = 256,
       width = 50,
       height = 50,
       notifier = function(value) --ROW 1 DELAY
       
               
                   --pattern variables
                   local song = renoise.song() 
                   local pattern = renoise.song().selected_pattern
                   local pattern_length = pattern.number_of_lines
                   local pattern_track = renoise.song().selected_pattern_track
                   
                   --if on fx track then return
                   if song.tracks[song.selected_track_index].type ~= renoise.Track.TRACK_TYPE_SEQUENCER then
                     status("Tool Only Works On Sequencer Tracks")
                     return
                   end
                   
                   --is record enabled
                   local record_val = 0    
                   if vb.views["record"].color[1] == RED_COORDINATE then
                     record_val = 1
                   end

                   --make volume column visible
                   if song.selected_track.delay_column_visible == false then
                     song.selected_track.delay_column_visible = true
                   end
                   --get number of visible columns as these will be the ones we change the values of
                   local visible_columns = song.selected_track.visible_note_columns
                      
                      
                   --default values for the range in pattern for tool to effect
                   ----------------------------------------------------------
                   local start_line = 1
                   local end_line = pattern_length

                   --if record enabled then set the values to the shorter range
                   if record_val == 1 then
                     start_line = renoise.song().selected_line_index 
                     end_line = start_line + 1
                   end
                   
                   --lua counts from 1, renoise pattern ed counts from 0, so:
                   value = value - 1
                   
                   for row = start_line,end_line do --pattern_length do
                     if row % 2 == 0 then
                       --do nothing
                     else
                       --set the delay value
                       for col = 1,visible_columns do
                         if  pattern_track:line(row):note_column(col).note_string ~= "---" then
                         --set the column values
                           pattern_track:line(row):note_column(col).delay_value = value
                         end
                       end
                     end
                   end
                 end
                  
                  
                  
     
      },
       --Clear [X] Button    
       vb:button{
        text = "X",
        notifier = function()
        
                    local song = renoise.song()
                    local visible_columns = song.selected_track.visible_note_columns
                    
                     --loop to clear rotary related values related                    
                    for row = 1, #song.selected_pattern_track.lines do
                      if row % 2 == 0 then
                       --do nothing
                      else
                       --clear the delay column
                        for col = 1,visible_columns do
                          song.selected_pattern_track:line(row):note_column(col).delay_value = renoise.PatternLine.EMPTY_DELAY --DELAY
                        end
                      end
                    end    
                  end--fn
       },--button 
     
      },--vert align(top ror Delay)
      
     
      
      --spacer
      vb:text{
       text = "  ",
      },
      --------------------------------------------------------------------
      --ROW 1 PANNING
      --------------------------------------------------------------------
      
     vb:vertical_aligner{ --contains pan rotary and [X] button
      mode = "justify",
     
      vb:rotary{
       min = 1,
       max = 128,
       width = 40,
       height = 40,
       notifier = function(value)  --ROW 1 PANNING
       
                   --pattern variables
                   local song = renoise.song() 
                   local pattern = renoise.song().selected_pattern
                   local pattern_length = pattern.number_of_lines
                   local pattern_track = renoise.song().selected_pattern_track
                   
                   --if on fx track then return
                   if song.tracks[song.selected_track_index].type ~= renoise.Track.TRACK_TYPE_SEQUENCER then
                     status("Tool Only Works On Sequencer Tracks")
                     return
                   end
                    --is record enabled
                   local record_val = 0    
                   if vb.views["record"].color[1] == RED_COORDINATE then
                     record_val = 1
                   end
                   --make volume column visible
                   if song.selected_track.panning_column_visible == false then
                     song.selected_track.panning_column_visible = true
                   end
                   --get number of visible columns as these will be the ones we change the values of
                   local visible_columns = song.selected_track.visible_note_columns
                      
                      
                   --default values for the range in pattern for tool to effect
                   ----------------------------------------------------------
                   local start_line = 1
                   local end_line = pattern_length

                   --if record enabled then set the values to the shorter range
                   if record_val == 1 then
                     start_line = renoise.song().selected_line_index 
                     end_line = start_line + 1
                   end
                   
                   --lua counts from 1, renoise pattern ed counts from 0, so:
                   value = value - 1
                                
                   for row = start_line,end_line do --pattern_length do
                                   
                     if row % 2 == 0 then
                       --do nothing
                     else
                        --set the delay value
                       for col = 1,visible_columns do
                         if pattern_track:line(row):note_column(col).note_string ~= "---" then 
                           --set the column values
                           pattern_track:line(row):note_column(col).panning_value = value
                         end
                       end
                     end
                   end
                 end
       
                 
     
      },
       
      --Clear [X] Button    
       vb:button{
        text = "X",
        notifier = function()
        
                    local song = renoise.song()
                    local visible_columns = song.selected_track.visible_note_columns
                    
                     --loop to clear rotary related values related                    
                    for row = 1, #song.selected_pattern_track.lines do
                      if row % 2 == 0 then
                       --do nothing
                      else
                       --clear the delay column
                        for col = 1,visible_columns do
                          song.selected_pattern_track:line(row):note_column(col).panning_value = renoise.PatternLine.EMPTY_PANNING --PAN
                        end
                      end
                    end    
                  end--fn
       },--button 
     
      },--vert align(top ror Delay)
      
      
   
     },--end of rotarys row 1
     
     vb:text{
      text = "Swing Rows (odd):",
     },
     --------------------------------------------
     --Rotaries 2
     --------------------------------------------
      vb:row{
       margin = 10,
       style = "group",
     
       vb:vertical_aligner{ --contains rotary and [X] button
        mode = "justify",
     
     
      vb:rotary{
       min = 1,
       max = 130,
       width = 50,
       height = 50,
       notifier = function(value) --ROW 2 VOLUME
       
                   --pattern variables
                   local song = renoise.song() 
                   local pattern = renoise.song().selected_pattern
                   local pattern_length = pattern.number_of_lines
                   local pattern_track = renoise.song().selected_pattern_track
                   
                   --if on fx track then return
                   if song.tracks[song.selected_track_index].type ~= renoise.Track.TRACK_TYPE_SEQUENCER then
                     status("Tool Only Works On Sequencer Tracks")
                     return
                   end
                    --is record enabled
                   local record_val = 0    
                   if vb.views["record"].color[1] == RED_COORDINATE then
                     record_val = 1
                   end
                   --make volume column visible
                   if song.selected_track.volume_column_visible == false then
                     song.selected_track.volume_column_visible = true
                   end
                   --get number of visible columns as these will be the ones we change the values of
                   local visible_columns = song.selected_track.visible_note_columns
                      
                      
                   --default values for the range in pattern for tool to effect
                   ----------------------------------------------------------
                   local start_line = 1
                   local end_line = pattern_length

                   --if record enabled then set the values to the shorter range
                   if record_val == 1 then
                     start_line = renoise.song().selected_line_index 
                     end_line = start_line + 1
                   end
                   
                   --lua counts from 1, renoise pattern ed counts from 0, so:
                   value = value - 1
                 
                   --when volume is at max, clear the volume column as this is tracker default
                   if value == 129 then
                     value = renoise.PatternLine.EMPTY_VOLUME --(EMPTY_VOL == 255)
                   end
                                      
                   for row = start_line,end_line do --pattern_length do
                     
                     if row % 2 ~= 0 then
                      --do nothing
                     else
                     --set the delay value
                       for col = 1,visible_columns do
                         if pattern_track:line(row):note_column(col).note_string ~= "---" then 
                         --set the column values
                           pattern_track:line(row):note_column(col).volume_value = value
                         end
                       end
                     end
                   end
                 end
                       
                      
                      
                     
               
      },
      
      
      --Clear [X] Button    
       vb:button{
        text = "X",
        notifier = function()--ROW 2 VOLUME
        
                    local song = renoise.song()
                    local visible_columns = song.selected_track.visible_note_columns
                    
                     --loop to clear rotary related values related                    
                    for row = 1, #song.selected_pattern_track.lines do
                      if row % 2 ~= 0 then
                       --do nothing
                      else
                       --clear the delay column
                        for col = 1,visible_columns do
                          song.selected_pattern_track:line(row):note_column(col).volume_value = renoise.PatternLine.EMPTY_VOLUME
                        end
                      end
                    end    
                  end--fn
       },--button 
     
      },--vert align(top ror Delay)
      
      --spacer
      vb:text{
       text = "  ",
       
        },
       
       --delay
      ---------------------------------------------------------------------------------------
      
       vb:vertical_aligner{ --contains rotary and [X] button
        mode = "justify",
        
      vb:rotary{
       min = 1,
       max = 256,
       width = 50,
       height = 50,
       notifier = function(value) --ROW 2 DELAY
       
                   --pattern variables
                   local song = renoise.song() 
                   local pattern = renoise.song().selected_pattern
                   local pattern_length = pattern.number_of_lines
                   local pattern_track = renoise.song().selected_pattern_track
                   
                   --if on fx track then return
                   if song.tracks[song.selected_track_index].type ~= renoise.Track.TRACK_TYPE_SEQUENCER then
                     status("Tool Only Works On Sequencer Tracks")
                     return
                   end
                   --is record enabled
                   local record_val = 0    
                   if vb.views["record"].color[1] == RED_COORDINATE then
                     record_val = 1
                   end
                    --make volume column visible
                   if song.selected_track.delay_column_visible == false then
                     song.selected_track.delay_column_visible = true
                   end
                   --get number of visible columns as these will be the ones we change the values of
                   local visible_columns = song.selected_track.visible_note_columns
                      
                      
                   --default values for the range in pattern for tool to effect
                   ----------------------------------------------------------
                   local start_line = 1
                   local end_line = pattern_length

                   --if record enabled then set the values to the shorter range
                   if record_val == 1 then
                     start_line = renoise.song().selected_line_index 
                     end_line = start_line + 1
                   end
                   
                   --lua counts from 1, renoise pattern ed counts from 0, so:
                   value = value - 1
                 
                   for row = start_line,end_line do --pattern_length do
                 
                     if row % 2 ~= 0 then
                     --do nothing
                     else
                       --set the delay value
                       for col = 1,visible_columns do
                         if pattern_track:line(row):note_column(col).note_string ~= "---" then 
                           --set the column values
                           pattern_track:line(row):note_column(col).delay_value = value
                         end
                       end
                     end
                   end 
                 end
                  
                  
                  
     
      },
        --Clear [X] Button    
       vb:button{
        text = "X",
        notifier = function()
        
                    local song = renoise.song()
                    local visible_columns = song.selected_track.visible_note_columns
                    
                     --loop to clear rotary related values related                    
                    for row = 1, #song.selected_pattern_track.lines do
                      if row % 2 ~= 0 then
                       --do nothing
                      else
                       --clear the delay column
                        for col = 1,visible_columns do
                          song.selected_pattern_track:line(row):note_column(col).delay_value = renoise.PatternLine.EMPTY_DELAY
                        end
                      end
                    end    
                  end--fn
       },--button 
     
      },--vert align(top ror Delay)
      
     
      
      --spacer
      vb:text{
       text = "  ",
      },
      
       --panning
      --------------------------------------------------------------------
     vb:vertical_aligner{ --contains rotary and [X] button
      mode = "justify",
       
      vb:rotary{
       min = 1,
       max = 129,
       width = 40,
       height = 40,
       notifier = function(value) --ROW 2 PANNING
       
                   --pattern variables
                   local song = renoise.song() 
                   local pattern = renoise.song().selected_pattern
                   local pattern_length = pattern.number_of_lines
                   local pattern_track = renoise.song().selected_pattern_track
                   
                   --if on fx track then return
                   if song.tracks[song.selected_track_index].type ~= renoise.Track.TRACK_TYPE_SEQUENCER then
                     status("Tool Only Works On Sequencer Tracks")
                     return
                   end
                   --is record enabled
                   local record_val = 0    
                   if vb.views["record"].color[1] == RED_COORDINATE then
                     record_val = 1
                   end
                    --make volume column visible
                   if song.selected_track.panning_column_visible == false then
                     song.selected_track.panning_column_visible = true
                   end
                   --get number of visible columns as these will be the ones we change the values of
                   local visible_columns = song.selected_track.visible_note_columns
                      
                      
                   --default values for the range in pattern for tool to effect
                   ----------------------------------------------------------
                   local start_line = 1
                   local end_line = pattern_length

                   --if record enabled then set the values to the shorter range
                   if record_val == 1 then
                     start_line = renoise.song().selected_line_index 
                     end_line = start_line + 1--
                   end
                   
                   --lua counts from 1, renoise pattern ed counts from 0, so:
                   value = value - 1
                                      
                   for row = start_line,end_line do --pattern_length do
                 
                     if row % 2 ~= 0 then
                      --do nothing
                     else
                       --set the delay value
                       for col = 1,visible_columns do
                         if pattern_track:line(row):note_column(col).note_string ~= "---" then
                           --set the column values
                           pattern_track:line(row):note_column(col).panning_value = value
                         end
                       end
                     end 
                   end
                 end
       
                 
     
      },
        --Clear [X] Button    
       vb:button{
        text = "X",
        notifier = function()
        
                    local song = renoise.song()
                    local visible_columns = song.selected_track.visible_note_columns
                    
                     --loop to clear rotary related values related                    
                    for row = 1, #song.selected_pattern_track.lines do
                      if row % 2 ~= 0 then
                       --do nothing
                      else
                       --clear the delay column
                        for col = 1,visible_columns do
                          song.selected_pattern_track:line(row):note_column(col).panning_value = renoise.PatternLine.EMPTY_PANNING
                        end
                      end
                    end    
                  end--fn
       },--button 
     
      },--vert align(top ror Delay)
      
      
   
     },--end of rotarys
     
   vb:horizontal_aligner{
   margin = 10,
    
    vb:button{
     text = "Realtime Record",
     height = 25,
     width = 100,
     id = "record",
     color = COLOR_GREY,
     notifier = function()
                  --toggle color from grey to red
                  if vb.views["record"].color[1] == RED_COORDINATE then
                    vb.views["record"].color = COLOR_GREY 
                  else
                    vb.views["record"].color = COLOR_RED
                  end 
                end,
    
    },
   }, --h_aligner 
   
  
   
   
   
 
   --[[ 
    vb:button{
     text = "Paste to Whole Track",
     notifier = function()
                
                  local song = renoise.song()
                  local index = song.selected_track_index
                  local visible_columns = song.selected_track.visible_note_columns
                  local value = renoise.song().selected_pattern_track:line(2):note_column(1).delay_value
                  
                  for pattern = 1, #song.patterns do
                     
                    for row = 1, #song:pattern(pattern):track(index).lines do
                    --  if row % 2 ~= 0 then
                       --do nothing
                     -- else
                       --set the delay value
                        for col = 1,visible_columns do
                          song:pattern(pattern):track(index):line(row):note_column(col).volume_value = value
                          song:pattern(pattern):track(index):line(row):note_column(col).delay_value = value
                          song:pattern(pattern):track(index):line(row):note_column(col).panning_value = value
                        end
                    --  end
                    end
                  end
                
                end    

   },--]]
  },
  

 }--end column
 --------------------------------------------------
 
 --------------------------------------------------
 --dialog init and functions
 ---------------------------
 
  --key Handler
  -------------
  local function my_keyhandler_func(dialog,key)
  
     --hack: toggle keyboard  lock state to allow pattern ed to receive key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
  
     --if escape pressed then close the dialog else return key to renoise
     if not (key.modifiers == "" and key.name == "esc") then
        return key
     else
       dialog:close()
     end
  end     
   
  --show dialog
  --------------
  my_dialog = renoise.app():show_custom_dialog(title, dialog_content,my_keyhandler_func)
  
  --close dialog function --for releasing app
  ------------------------------------------
  local function closer(d)    
     if d and d.visible then
       d:close()
     end
  end
  
  --notifier to close dialog on load new song
  -------------------------------------------
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)

end







